package tangram

// PPG nacitanie objednavky z databazy, formatovanie do HTML, odoslanie mailom
// [sql] SQL connection, [smtp] mail server podla Tangram.ini, [dir] adresar so skriptom, [data] musi obsahovat OBPHV.XX
def result = runScript (sql, smtp, dir, data)
return result

// Spustenie skriptu
private static String runScript(tangram.SQLconn sql, tangram.SMTP smtp, String dir, String data)
{
    // println("loading ORDER $data")
    def obj = loadOrder(sql, data)
    // println("formatting HTML")
    def html = HTML.process(obj, "$dir/OrderNotification.ftlh")

    // odoslanie SMTP (e-mail prijemcu z hlavicky objednavky)
    def receiver = obj.getString("delivery_email")
	if (receiver.isEmpty()) throw new TangramException("order header, <delivery_email> field is empty")
	
	def StoreEmail = obj.xpEmail
	if (StoreEmail.isEmpty()) throw new TangramException("order header, <store_email> field is empty")
	
    smtp.clearBody()
    smtp.msgFrom  = 'eshop@domyfarieb.sk'
    smtp.msgTo    = receiver
    smtp.msgSubject = createSubject(obj)	// "Potvrdenie o prijatej objednávke ${obj.cdok}"
    smtp.addHtml(html)
    // smtp.addFile('F:/temp/invoice.html')
    smtp.send()
    // informacia - vysledok
    def info = "Notifikácia: ${createSubject(obj)} >>> $receiver"
    Log.info(info)
	
	//kopie notifikací
	if (obj.rsstav=='1') {
						smtp.msgSubject = ">NOVÁ OBJEDNÁVKA SK< - ${obj.druhdok}/${obj.cdok} - KOPIA EMAILU pro $receiver"
						smtp.msgTo    = 'milan.durdik@ppg.com'
						smtp.send()
					//	smtp.msgTo    = StoreEmail
					//	smtp.send()
					//	smtp.msgTo    = receiverManager(obj)
					//	smtp.send()
						}
	//KONEC kopie notifikací
	
    return info
}

// Nacitanie obsahu objednavky do buffera (hlavicka aj riadky), vhodneho pre templating
private static DataBuffer loadOrder(tangram.SQLconn sql, String xx)
{
    def totalBdph = new BigNumber()
    def totalSdph = new BigNumber()

    def data = sql.querySingle("SELECT * FROM OBPH WHERE Xx='$xx'")
    def rows = new ArrayList<DataBuffer>()
    def selectRows = """
            SELECT R.Xn, R.Kod, R.Popis, R.Mn, R.Mnzost, R.Cm_bdph, R.Cm_sdph, R.Zlava, R.Sadzba_dph, R.Akcia,
                nvl(R.Znazov, T.Nazov) as Nazov, T.Mj, T.Jmj, T.Jkoef,
                round(R.Mn * R.Cm_bdph, 2) as Sum_bdph,
                round(R.Mn * R.Cm_sdph, 2) as Sum_sdph
            FROM OBPR R LEFT JOIN TOVARY T ON (T.Xx=R.Kod)
            WHERE R.Xh='$xx' and nvl(R.Blok,'#') <> 'R'
            ORDER BY R.Xn
        """.stripIndent()
    def rs = sql.queryRows(selectRows)
    while (rs.next())
    {
        // println("ROW ${rs.row}")
        // data z resultsetu sa musia skopirovat, lebo interny buffer sa po kazdom riadku vymazava
        def rowdata = new DataBuffer(rs.data)
        rows.add(rowdata)
        totalBdph += rowdata.getBigNumber("sum_bdph")
        totalSdph += rowdata.getBigNumber("sum_sdph")
    }
    rs.close()
    // println("SUM $totalBdph $totalSdph")
    // pole riadkov a sumy za objednavku
    data.rows = rows
    data.sum_bdph = totalBdph
    data.sum_sdph = totalSdph

    // adresa a telefon nasej pobocky, ktora vybavuje objednavku
    def xp = data.getString("xp")
		
    def adresa = sql.querySingle("SELECT * FROM ADRESA WHERE Xx='$xp'")
    data.xpNazov1  = adresa.nazov1 ?: ""
    data.xpNazov2  = adresa.nazov2 ?: ""
    data.xpUlica   = adresa.ulica ?: ""
    data.xpPsc     = adresa.psc ?: ""
    data.xpMesto   = adresa.mesto ?: ""
    data.xpTelefon = adresa.telefon ?: ""
    data.xpEmail   = adresa.email ?: ""
	data.xpManager = adresa.typ ?: ""					//přidaný typ

    Log.debug("ORDER DATA=$data")
    return data
}

// Vytvorenie SUBJECT
private static String createSubject (DataBuffer obj)
{
    def status = obj.getString("rsstav")
	switch(status) 
	{ 
      case '1': return "Potvrdenie o prijatí objednávky ${obj.druhdok}/${obj.cdok}"
      case '2': return "Zmena stavu objednávky ${obj.druhdok}/${obj.cdok}"
	  case '3': return "Zmena stavu objednávky ${obj.druhdok}/${obj.cdok}"
	  case '4': return "Objednávka ${obj.druhdok}/${obj.cdok} je pripravená"
	  case '5': return "Objednávka ${obj.druhdok}/${obj.cdok} bola vyzdvihnutá"
	  case '6': return "Zrušenie objednávky ${obj.druhdok}/${obj.cdok}"
      default: return ""
    } 
}

// Vytvorenie receiverManager // nový adresát - manager
private static String receiverManager (DataBuffer obj)
{
    def manager = obj.getString("xpmanager")
	switch(manager) 
	{ 
      case '01': return "it@dumbarev.cz"
      case '02': return "it@dumbarev.cz"
	  case '03': return "it@dumbarev.cz"
	  default: return "it@dumbarev.cz"
    } 
}
