package tangram

import businessLogic.FAV
import businessLogic.TN_MSG

// PPG vytvorenie "zalohovej" FAV k OBP zaplatenej vopred (cez platobnu branu)
// "data" obsahuje OBPH.XX
// FAV.OBJCIS = OBPH.DRUHDOK/CDOK (nase interne cislo)
// FAV.SP_UHRADY = uhradene vopred
processOrderPayment(sql, data)

// Kontrola MSG-queue, hladame spravy "OrderPayment"
private static processOrderPayment(SQLconn sql, String msgData)
{
    Log.INSTANCE.info("ORDER PAYMENT (vytvorenie faktúry k zaplatenej objednávke), xx=$msgData")
    // vytvorenie faktury, msg.data obsahuje OBPH.XX, vrati informaciu o fakture
    def info = createFAV(sql, msgData)
    // informacia - vysledok operacie
    return info
}

// Odoslanie vsetkych produktov s novsim timestampom
private static String createFAV(SQLconn sql, String xxObp)
{
    // Hlavicka objednavky
    def obph = sql.querySingle("SELECT * FROM OBPH WHERE Xx='$xxObp'")
    if (obph.getString("xx").isEmpty())
        return "Objednávka nenájdená, kód $xxObp"

    // buffer pre fakturu
    def fav = new FAV(sql)

    // hlavicka faktury (finta: do stlpca PRILOHY si odlozime e-mail zakaznika)
    def favxx   = sql.createXX()
    fav.xx      = favxx
    fav.df      = "DDE"
    fav.faktc   = ""      // cislo faktury sa vygeneruje
    fav.vs      = obph.getString("vs_uhrady")
    fav.ks      = "0308"
    fav.objcis  = "${obph.druhdok}/${obph.cdok}"
    fav.str     = obph.xp
    fav.c       = "EUR"
    fav.firma   = obph.firma
    fav.pobocka = obph.pobocka
    fav.xp      = obph.xp
    fav.d_zdanpl= obph.getDate("datum")
    fav.prilohy = obph.getString("delivery_email")

    // Sumarizacia riadkov podla sadzby DPH
    def select ="SELECT Sadzba_dph, sum(round(Mn*Cm_sdph,2)) as Suma FROM OBPR WHERE Xh='$xxObp' GROUP BY Sadzba_dph ORDER BY 1"
    def rs = sql.queryRows(select)
    while (rs.next())
    {
        def dph = rs.getBigNumber("sadzba_dph")
        def suma = rs.getBigNumber("suma")
        fav.dphZhora("VY$dph", dph, suma)
    }
    rs.close()

    // doplnenie a dopocitanie poloziek, ulozenie do databazy
    fav.calc()
    fav.saveToDB()

    // vytvorime poziadavku na odoslanie faktury mailom
    TN_MSG.write(sql, "InvoiceNotification", favxx)

    // Zapis do LOGu a vratime info, ktore sa zapise do povodnej spravy ako vysledok
    def info = "Objednávka ${obph.druhdok}/${obph.cdok} ${obph.datum}, faktúra ${fav.df}/${fav.faktc}, var.symbol ${fav.vs}"
    Log.INSTANCE.info ("PPG OBP->FAV $info")
    return info
}
