import businessLogic.ppg.XpShopCode
import tangram.DataBuffer
import tangram.Log
import tangram.SQLconn
import tangram.SQLtable
import tangram.http.TangramHttpRequest

// CUSTOMERCREATE vlozenie noveho zakaznika
urlCustomerUpdate(sql, request)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlCustomerUpdate(SQLconn sql, TangramHttpRequest request)
{
    // CustomerID je v QUERY, vstupne data su v request.bodyMap (rozparsovany JSON)
    def body = request.bodyMap
    // Pripravime tabulku, nacitame povodny zaznam z databazy, ak sa nenajde vrati sa chyba
    def id = request.queryMap.getString("id")
    if (id.isEmpty()) { request.sendError(id, 'IDNULL', "Customer ID not specified"); return }
    def row = sql.querySingle("SELECT F, 1 as Count FROM FIRMY WHERE Xx='$id'")
    if (!row.count) { request.sendError(id, 'NOTFOUND', "Kód zákazníka $id nenájdený v databáze"); return }

    def b2b = !(row.getString('f') == 'O')

    // Vytiahneme vsetky hodnoty z request-body, naplnime body->upd
    def upd = new DataBuffer()
    def errorList = createBody (upd, body, b2b)

    // Nespracovane polia vyhodia chybu
    if (!errorList.isEmpty()) // { request.sendError(id, 'DENIED', "Access denied: $errorList"); return }
        Log.error('UPDATE nepovolené polia ' + errorList)

    // Update zaznamu v databaze
    def f = new SQLtable ('FIRMY', sql)
    f.update(id, upd)
    f.close()

    // koniec OK
    Log.info("UPDATE CUSTOMER, id=$id")
    request.sendOk(id, 'Zákazník zmenený v databáze')
}

// Naplnenie stlpcov tabulky FIRMY, transformuju sa nazvy, kontroluju sa povolene stlpce pre kazdy rezim
// [upd] = zoznam poli v tabulke FIRMY, ktore sa maju updatovat
// [body] = zoznam poli z requestu
// Vrati: zoznam chyb alebo prazdny retazec ak je vsetko OK
private static String createBody (DataBuffer upd, DataBuffer body, boolean b2b)
{
    // B2B: true=firma, false=obcan
    def errorList = ''
    // zoznam povolenych poli, preklad na databazove nazvy
    def translate = [email: 'email', phone: 'telefon',
                     delivery_company: 'delivery_company', delivery_firstname: 'delivery_firstname', delivery_lastname: 'delivery_lastname',
                     delivery_addr1: 'delivery_addr1', delivery_addr2: 'delivery_addr2',
                     delivery_post: 'delivery_post', delivery_city: 'delivery_city', delivery_country: 'delivery_country',
                     default_shop_id: 'xp']
    // ak nie je B2B, pridame k povolenym aj nazov a adresu firmy
    if (!b2b) translate << [company_name: 'nazov1', invoice_addr1: 'ulica', invoice_addr2: 'nazov2',
                            invoice_post: 'psc', invoice_city: 'mesto', invoice_country: 'stat']
    // ak je OBCAN a meni sa Meno aj Priezvisko, tak prepiseme aj Nazov firmy
    if (!b2b && body.delivery_firstname && body.delivery_lastname)
        body.company_name = body.delivery_firstname + ' ' + body.delivery_lastname
    // do [upd] vytvorime zoznam databazovych stlpcov s novymi hodnotami
    body.each { key, value ->
        def dbColumn = translate.get(key)
        // Kod pobocky: orezanie prefixu
        if (dbColumn == "xp") value = XpShopCode.removePrefix(value,'')
        Log.debug("$key ($value) -> $dbColumn")
        if (!dbColumn) errorList += "$key "
        else upd.put(dbColumn, value)
    }

    return errorList
}
