import businessLogic.ppg.PpgOrder
import businessLogic.ppg.XpShopCode
import tangram.ConfigFile
import tangram.JsonWriter
import tangram.SQLconn
import tangram.http.TangramHttpRequest

// ORDER CREATE, kontrola platnosti PROMO kuponu
// Parametre requestu: CUSTOMER=kod zakaznika, COUPON=kod kuponu
urlOrderCreate(sql, request, cfg)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlOrderCreate(SQLconn sql, TangramHttpRequest request, ConfigFile cfg)
{
    // objednavka
    def order = new PpgOrder()
    order.loadJson(sql, cfg, request.bodyMap)
    // orezanie prefixu z kodu predajne (14.11.2022)
    // order.header.delivery_shop = XpShopCode.removePrefix(order.header.delivery_shop, "")
    // order.header.sklad = sql.queryValueStr("SELECT Sklad, Nazov2 FROM ADRESA WHERE Xx='${order.header.delivery_shop}'")
    // vypocet ciem, ulozenie objednavky
    order.calculatePrices(sql)
    order.calculateDelivery(sql)
    order.saveDB(sql)

    // Response header + body
    request.sendHeaderJSON()
    JsonWriter.write(request.writer, order)
}
