import businessLogic.SkUtils
import businessLogic.ppg.PpgOrder
import businessLogic.ppg.PpgOrderHeader
import businessLogic.ppg.XpShopCode
import tangram.*
import tangram.http.TangramHttpRequest

// ORDERLIST zoznam objednavok, vrati pole riadkov, JSON, UTF-8
urlOrderList(sql, request, cfg)

private static void urlOrderList (SQLconn sql, TangramHttpRequest request, ConfigFile cfg)
{
    // Ak sa parameter DAYS nezada, datum sa nefiltruje
    int days = request.queryMap.getInt('days', -1)
    def customer = request.queryMap.getString('customer')
    def customerFirma = SkUtils.firmaFirma(customer)
    def customerPobocka = SkUtils.firmaPobocka(customer)
    def country = cfg.str('EshopCountry')
    def filter = new SQLfilter()
    if (days >= 0)
        filter.and("Datum >= (trunc(sysdate)-$days)")
    filter.strExact('Druhdok', 'ESHOP')
    filter.strExact('Firma', customerFirma)
    filter.strExact('Pobocka', customerPobocka)
    def select = "SELECT Xx FROM OBPH WHERE $filter ORDER BY Xid desc"
    Log.debug("ORDERLIST: $select")

    // Zoznam objednavok najprv nacitame do pola, aby sa lahsie serializovali
    def orders = new ArrayList<PpgOrderHeader>()
    def heads = sql.queryRows (select)
    while (heads.next())
    {
        def xx = heads.getString('xx')
        def order = new PpgOrder()
        order.loadDB(sql, xx)
        // doplnenie prefixu do kodu predajne (14.11.2022)
        order.header.delivery_shop = XpShopCode.addPrefix(order.header.delivery_shop, country)
        orders.add(order.header)
    }
    heads.close()

    // Response header
    request.sendHeaderJSON()
    def data = new DataBuffer()
    data.put('orders', orders)
    JsonWriter.write(request.writer, data)
}
