import tangram.ConfigFile
import tangram.Log
import tangram.SQLconn
import tangram.SQLfilter
import tangram.TangramJsonWriter
import tangram.http.TangramHttpRequest

// QUOTELIST: zoznam cenovych ponuk pre vybraneho zakaznika, vrati pole riadkov, JSON, UTF-8
// args: customer = kod zakaznika
urlQuoteList(sql, request, json, cfg)

private static void urlQuoteList(SQLconn sql, TangramHttpRequest request, TangramJsonWriter json, ConfigFile cfg)
{
    def customer = request.queryMap.getString('customer')
    def country = cfg.str("EshopCountry")

    // filter: Firma + priznak "Ponuka" + priznak "otvorena ponuka" + datum otvorene obdobie OBP
    // TODO >> filtrovat len "otvorene ponuky" a obdobie objednavok (tabulka OBDOBIE, Xx=OBP)
    def filter = new SQLfilter()
    filter.strExact("H.Firmaxx", customer)
    filter.and("H.Datum >= DATE '2022-01-01'")
    filter.and("H.Stav='A'")
    filter.and("R.Totald_iv<>0")
    Log.debug("filter: $filter")

    // vynechane H.Spedicia "spedition",
    def select = """
        SELECT H.Xx "quote_id", 
            H.Druhdok || '/' || to_char(H.Cdok) "quote_visible_id",
            H.Druhdok "quote_group",
            H.Cdok "quote_number",
            H.Firmaxx "customer_id",
            H.Censkup "pricegroup",
            H.Zl_f "discount",
            H.Datum "date",
            H.Popis "comment",
            '$country' || H.Xp "delivery_shop",
            H.Delivery_company,
            H.Delivery_firstname,
            H.Delivery_lastname,
            H.Delivery_addr1,
            H.Delivery_addr2,
            H.Delivery_post,
            H.Delivery_city,
            H.Delivery_country,
            H.Delivery_email,
            H.Delivery_phone,
            R.Totalb_bv,
            R.Totalb_iv,
            R.Totald_bv,
            R.Totald_iv
        FROM OBCPH H JOIN 
        ( SELECT Xh, 
			sum(round(Cm_jedn * Mn, 2)) as Totalb_bv, 
			sum(round(Cd_jedn * Mn, 2)) as Totalb_iv, 
			sum(Cm_suma) as Totald_bv, 
			sum(Cd_suma) as Totald_iv
          FROM OBCPR GROUP BY Xh
        ) R ON (R.Xh=H.Xx) 
        WHERE $filter ORDER BY H.Druhdok, H.Cdok
    """.stripMargin()
    def rows = sql.queryRows (select)

    // Response header
    request.sendHeaderJSON()
    // Reponse body
    json.begin()
    json.resultset(rows, 'quotes')
    json.end()

    Log.debug("rows: ${rows.getRow()}")
    rows.close()
}
