import tangram.ConfigFile
import tangram.SQLconn
import tangram.TangramJsonWriter
import tangram.http.TangramHttpRequest

// STORELIST zoznam predajni, vrati pole riadkov, JSON, UTF-8
urlStoreList(sql, request, json, cfg)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlStoreList (SQLconn sql, TangramHttpRequest request, TangramJsonWriter json, ConfigFile cfg)
{
    // Kod statu sa pouzije ako prefix
    def country = cfg.str("EshopCountry")
    // Zoznam predajni: TYP obsahuje kod manazera predajne, prazdny kod znamena zrusenu predajnu, velkosklad a pod.
    // JK,MF,RN = regionální manager - franchizová prodejna
    def select = """
             SELECT '$country' || Xx as id,
             case when Typ in ('JK','MF','RN') then 'FRANCHISE' else 'PPG' end as type, 
             Nazov2 as name, ' ' as addr1, ' ' as addr2, ' ' as city, ' ' as post, Okres as county, Kraj as region,
             Referent as person, Telefon as phone, Email, Register
             FROM ADRESA WHERE Typ is not null ORDER BY Xx
        """.stripIndent()
    def rows = sql.queryRows (select, request.queryMap)
    // Response header
    request.sendHeaderJSON()
    // Reponse body
    json.begin()
    json.resultset(rows, "items")
    json.end()
    rows.close()
}
