// SURFPOINT/ORDER?id=xxxxx (vyhladanie OBP podla XX, vrati hlavicku + pole riadkov, JSON, UTF-8)
// Vstupne parametre: request (request+response), sql (tangram.SQLConn), query (parametre requestu), logger
// 1. nacitanie OBPH do mapy
// 2. vytvorenie resultsetu z OBPR
// 3. zapis OBPH do JSON
// 4. zapis riadkov do JSON

// Get data from database
def obph = sql.querySingle ("""
SELECT Xx as "id", Druhdok as "ordtype", Cdok as "ordnumber", Datum as "date", Popis as "text",
    case when Vyba is null then 'false' else 'true' end as "closed" 
FROM OBPH WHERE Xx=upper(:ID)
""", query )

def obpr = sql.queryRows ("""
SELECT R.Xn as "row", R.Kod as "itemid", T.Nazov as "name", R.Sadzba_dph as "vat", R.Cd_cena as "price", R.Mn as "qty"  
FROM OBPR R LEFT JOIN TOVARY T ON (T.Xx=R.Kod)
WHERE R.Xh=upper(:id) ORDER BY R.Xn
""", query)

// Request header: nezapisujeme, urobi to za nas handler po navrate
// Reponse body: zapisujeme len do bufferu, nesmieme urobit flush, to za nas urobi handler
json.begin()
json.map (obph, 'header')
json.arrayBegin('items')
while (obpr.next())
    json.map (obpr.data)
json.arrayEnd()
json.end()

