import tangram.BigNumber
import tangram.Log

// zoznam tovarov s aktualnou cenou (GET), query-parametre:
// [store=XXX] kod predajne (povinny)
// [minutes=nn] len zmenene zaznamy za poslednych n minut (ak sa neuvedie, bezi full-export)
urlPriceList (sql, request, json, cfg)

private static void urlPriceList (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    // Parametre z URL a konfiguracie (Tangram.ini)
    def store = request.queryMap.getString('store').toUpperCase()
    def minutes = request.queryMap.getInt('minutes')
    def censkup = cfg.str('EshopPriceGroup', 'MOC')
    def censkup2 = cfg.str('EshopPriceGroup2', 'COOP')
    def sku = request.queryMap.getString('sku')
//    def typceny = cfg.str('EshopPriceBasic', "'A','B'")

    def tovfilter = ''
    def expire = ''
    if (minutes) tovfilter = """
        and exists (select null FROM TOVARY X WHERE X.Xx=T.Xx and nvl(X.Xud,X.Xid) > (sysdate - interval '$minutes' minute))
           or exists (select null FROM TOVCENY X WHERE X.Kod=T.Xx and nvl(X.Xud,X.Xid) > (sysdate - interval '$minutes' minute))
		   or t.x_eslexp='A'
    """
   
    if (sku) tovfilter = """ and T.xx='$sku'"""

    // def cenfilter = "Kod=T.Xx and Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do)"
    // Log.debug ("store=$store, minutes=$minutes, filter=$tovfilter\ncena='$cenfilter'")
    
    // zistenie typu retazca
    def retazec= ""
    def row = sql.queryRows("SELECT typ from adresa where xx='$store'")
    while (row.next()) retazec=row.typ
    row.close()
	
    // Nacitanie riadkov z tabulky TOVARY
    def select = """
    SELECT T.*, C.Cm_sdph "price", C.Akcia "akcia",B.KodAkcia "akcia2", B.Cm_sdph "priceBasic",  C2.Cm_sdph "price2", F.Nazov1 "vyrobca", S.xn "scale_plu", povod.nazov "povod_nazov",C.zl_typ as zl_typ,B.zl_typ as zl_typ_b,C.typceny as typceny,B.typceny as typceny_b, RP.Cm_sdph as rp_price
    FROM TOVARY T 
	LEFT JOIN
	( SELECT Kod,
		max(Cm_sdph) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as Cm_sdph,
		max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as Akcia,
		max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
      WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and (Typceny='B' or (Typceny='D' and Adresa='$store') or (Typceny='C' and Adrtyp='$retazec'))
	  GROUP BY Kod
    ) C ON (C.Kod=T.Xx)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph,  
		 max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as KodAkcia,
		 max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		 max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
	  WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and Typceny='A'
	  GROUP BY Kod
	) B ON (B.Kod=T.Xx)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph,  
		 max(Akcia) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as KodAkcia,
		 max(zl_typ) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as zl_typ,
		 max(typceny) KEEP (DENSE_RANK FIRST ORDER BY Cm_sdph) as typceny
	  FROM TOVCENY
	  WHERE Censkup='$censkup' and (trunc(sysdate) between Datum_od and Datum_do) and (Typceny='A' or Typceny='B' or (Typceny='D' and Adresa='$store') or (Typceny='C' and Adrtyp='$retazec'))
	  GROUP BY Kod
	) RP	ON (RP.Kod=T.obal)
	LEFT JOIN
	( SELECT Kod, min(Cm_sdph) as Cm_sdph FROM TOVCENY
	  WHERE Censkup='$censkup2' and (trunc(sysdate) between Datum_od and Datum_do) 
	  GROUP BY Kod
	) C2 ON (C2.Kod=T.Xx)
	LEFT JOIN
	(SELECT xx,nazov1,Mesto,Ulica FROM FIRMY) F ON (F.Xx=T.Vyrobca)
	LEFT JOIN
	(SELECT Kod,xn FROM vahyr group by kod,xn) S ON (T.Xx=S.Kod)
	LEFT JOIN
	(SELECT xx,nazov FROM c_staty) povod ON (T.povod=povod.xx)
	WHERE neaktivna is null and t.xx not like '{%}' and t.xx not like 'MTZ%'
	$tovfilter
    ORDER BY T.Xx
    """
	
	Log.debug (select)

    def rows = sql.queryRows(select)

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.arrayBegin('items')
//     json.resultset(rows, 'items')
    while (rows.next())
    {
        // dopocitane hodnoty
        def kod = rows.getString("xx")
        def basic = rows.getBigNumber("priceBasic")
        def price = rows.getBigNumber("price")
        def price2 = rows.getBigNumber("price2")
        Log.debug("kod=$kod, basic=$basic, price=$price")
        def discount = new BigNumber()
        if (rows.scale_plu.nullOrZero) expire= null
	else expire = '24'
	if (price.nullOrZero) price = basic
        else discount = ((basic - price) / basic * (new BigNumber(100))).round(1)

        def jkoef = rows.getBigNumber("jkoef")
        def unitPrice = jkoef.nullOrZero ? new BigNumber() : (price / jkoef).round(3)
        def unitPrice2 = jkoef.nullOrZero ? new BigNumber() : (price2 / jkoef).round(3)

        // vyber typu template
	def typceny = rows.getString("typceny")
	if (typceny == '') typceny = rows.getString("typceny_b") 
	def kodAkcia = rows.akcia
        if (kodAkcia == null) kodAkcia = rows.akcia2
	def template = "1"
	if (price2 != '') template = "6"
	else if (kodAkcia == null && typceny == 'A') template = "1"
	else if (kodAkcia == null  && typceny != 'A') template = "2"
	else if (kodAkcia == "DNC") template = "3"
	else if (kodAkcia == "VZ") template = "4"
	else if (kodAkcia == "P") template = "1"
	else if (kodAkcia == "VA") template = "2"
	else if (kodAkcia == "TA") template = "2"
	else if (kodAkcia.indexOf("A") > 0) template = "2"
	else if (kodAkcia.indexOf("B") > 0) template = "2"
	else if (kodAkcia.indexOf("C") > 0) template = "2"
	else if (kodAkcia.indexOf("D") > 0) template = "2"
	else if (kodAkcia.indexOf("G") > 0) template = "2"
	else if (kodAkcia.indexOf("U") > 0) template = "2"
	else if (kodAkcia.indexOf("I") > 0) template = "3"
	else if (kodAkcia.indexOf("P") > 0) template = "3"
	else if (kodAkcia.indexOf("E") > 0) template = "4"
	else if (kodAkcia.indexOf("F") > 0) template = "4"
	else if (kodAkcia.indexOf("T") > 0) template = "3"
	else if (kodAkcia.indexOf("V") > 0) template = "3"
	else if (kodAkcia.indexOf("X") > 0) template = "2"
	else if (kodAkcia.indexOf("Y") > 0) template = "2"
        else template = "1"


        // zapis do JSON
        json.blockBegin()
			json.pair("sku", kod)
			json.pair("store", store)
			json.pair("retazec", retazec)
			json.pair("sku_pack", rows.obal)
			json.pair("rp_price", rows.rp_price)
			json.pair("name", rows.nazov)
			json.pair("short_name", rows.nazovplu)
			json.pair("unit_price", unitPrice)
			json.pair("unit_price2", unitPrice2)
			json.pair("unit", rows.jmj)
			if (rows.povod != null) json.pair("place_of_origin", rows.povod)
			if (rows.povod_nazov != null) json.pair("place_of_origin_name", rows.povod_nazov)
			json.pair("price", price)
			json.pair("price2", price2)
			json.pair("price_old", basic)
			json.pair("discount_value", discount)
			json.pair("spec", rows.zlozenie)
			json.pair("template", template)  
			json.pair("kod_akcia", kodAkcia)  
			json.pair("category", rows.druh)
			json.pair("allergen", rows.fo_alergeny)
			json.pair("product_type", rows.x_druhvyr)
			json.pair("manufacturer", rows.vyrobca)
			json.pair("scale_plu", rows.scale_plu)
			json.pair("expire", expire)
			//json.pair("typceny",typceny)


        // pole ciarovych kodov
        exportBarcodes(sql, json, kod)

	// zoznam precenenia
	def zl_typ = rows.getString("zl_typ")
	def zl_typ_b = rows.getString("zl_typ_b")
	if (zl_typ=='') zl_typ = zl_typ_b
        
	if (zl_typ!='A'){
		//json.pair("zl_typ", zl_typ)
		json.blockBegin('paging')
			json.blockBegin('3')
				json.pair("unit_price", (unitPrice*(new BigNumber(0.8))).round(3))
				json.pair("price", (price*(new BigNumber(0.8))).round(2))
				json.pair("discount_value", "20")
			json.blockEnd()
			json.blockBegin('4')
				json.pair("unit_price", (unitPrice*(new BigNumber(0.7))).round(3))
				json.pair("price", (price*(new BigNumber(0.7))).round(2))
				json.pair("discount_value", "30")
			json.blockEnd()
			json.blockBegin('5')
				json.pair("unit_price", (unitPrice*(new BigNumber(0.5))).round(3))
				json.pair("price", (price*(new BigNumber(0.5))).round(2))
				json.pair("discount_value", "50")
			json.blockEnd()
			json.blockBegin('6')			
				json.pair("unit_price", (unitPrice*(new BigNumber(0.5))).round(3))
				json.pair("price", (price*(new BigNumber(0.2))).round(2))
				json.pair("discount_value", "80")
			json.blockEnd()
		json.blockEnd()}



        // koniec bloku (jeden tovar)
        json.blockEnd()
    }
    json.arrayEnd()
    json.end()

    rows.close()
	sql.execute("update tovary set x_eslexp=null where x_eslexp='A'")
}

// export ciarovych kodov
private static void exportBarcodes (tangram.SQLconn sql, tangram.TangramJsonWriter json, String kod)
{
    // zoznam ciarovych kodov do Listu
    def barcodes = []
    def rows = sql.queryRows("SELECT Barcode FROM TOVBARCODE WHERE Kod='$kod' ORDER BY Barcode")
    while (rows.next()) barcodes.add(rows.barcode)
    rows.close()

    // export pola do JSON
    json.array(barcodes, "ean")
}
