import tangram.Log

// Nadobudacie ceny jedneho alebo vsetkych tovarov, za jeden alebo vsetky sklady, vracia min/max/priemer ceny
// [id] = kod tovaru (default vsetky oznacne e-shop)
// [store] = kod skladu (default vsetky sklady)
// filtruju sa len tovary s priznakom "e-shop"
urlPurchasePriceList (sql, request, json, cfg)

private static void urlPurchasePriceList (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    // Parametre z URL a konfiguracie (Tangram.ini)
    def id = request.queryMap.getString('id').toUpperCase()
    def store = request.queryMap.getString('store').toUpperCase()

    def tovfilter = (id ? "T.Xx='${id}'" : 'T.Flg_eshop is not null');
    def sklwhere = (store ? "WHERE Sklad='$store'" : '');
    Log.debug ("id=$id, store=$store, filter=$tovfilter, storefilter=$sklwhere")

    // API REQUEST: ciselnik sluzieb z tabulky TOVARY, optional filters: id=kod_tovaru
    // warning: parameter [id] sa z nejakeho dovodu neda pouzit vo where :id, musime urobit inject (skontrolovat SQL class)
    def select = """
    SELECT T.Xx "id", T.Nazov "name", Z.Ncmin "MinPrice", Z.Ncmax "MaxPrice", Z.Ncpriem "AvgPrice" 
    FROM TOVARY T
    LEFT JOIN 
    ( SELECT Kod, 
      min(case when(Mnp<>Mnv) then Nadcena end) as Ncmin, 
      max(case when(Mnp<>Mnv) then Nadcena end) as Ncmax,
      round (case when sum(Mnp-Mnv)<>0 then sum(Nadcena*(Mnp-Mnv))/sum(Mnp-Mnv) else max(Nadcena) KEEP (DENSE_RANK FIRST ORDER BY Origdatum desc) end, 5) as Ncpriem 
      FROM SKSTAVY $sklwhere GROUP BY Kod
    ) Z ON (T.Xx=Z.Kod)
    WHERE $tovfilter
    ORDER BY T.Xx
    """

    def rows = sql.queryRows(select)

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.resultset(rows, 'items')
    json.end()
    rows.close()

}
