import businessLogic.SkUtils
import tangram.TangramException

// vlozenie novej karty k existujucemu zakaznikovi
urlCardCreate (sql, request, json)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlCardCreate (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json)
{
    def body = request.bodyMap
    def cardId  = body.getString('id')
    def firmaXx = body.getString('customer')
    def firma   = SkUtils.firmaFirma(firmaXx)
    def pobocka = SkUtils.firmaPobocka(firmaXx)

    // Kontrola: povinne polia ID a CUSTOMER
    if (!cardId || !firmaXx)
    {
        request.sendError('', 'EMPTY', 'Fields [id] and [customer] must not be empty')
        return
    }
    // Kontrola: kod karty ID nesmie byt v databaze
    def count = sql.queryValueInt("SELECT count(*) FROM ECR_ZAK WHERE Xx='$cardId'")
    if (count)
    {
        request.sendError(cardId, 'EXIST', "Card [$cardId] already exists in database")
        return
    }

    // Vlozenie zaznamu do tabulky
    def db = sql.prepareTable('ECR_ZAK')

    db.xx    = cardId
    db.firma    = firma
    db.pobocka  = pobocka
    db.nazov    = body.name
    db.poznamka = body.comment

    db.insert()
    db.close()

    // Response header + body
    request.sendOk(cardId)
}
