import tangram.Log

// CustomerUpdate, zmena udajov o zakaznikovi. CustomerID aj vstupne data su v request.bodyMap (POST).
urlCustomerUpdate(sql, request, json)

//
private void urlCustomerUpdate(tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json)
{
    def body = request.bodyMap
    // Pripravime tabulku, nacitame povodny zaznam z databazy, ak sa nenajde vrati sa chyba
    def id = body.getString("id")
    if (id.isEmpty()) { request.sendError(id, 'IDNULL', "Customer ID not specified"); return }
    def row = sql.querySingle("SELECT F, 1 as Count FROM FIRMY WHERE Xx='$id'")
    if (!row.count) { request.sendError(id, 'NOTFOUND', "Customer ID $id not found in database"); return }

    def b2b = (row.getString('f') != 'O')

    // Vytiahneme vsetky hodnoty z request-body, naplnime body->upd
    def upd = new tangram.DataBuffer()
    def errorList = parseInputData (upd, body, b2b)

    // Nespracovane polia vyhodia chybu
    if (!errorList.isEmpty())
        Log.error("UPDATE nepovolené polia [$errorList]")

    // Update zaznamu v databaze
    def f = new tangram.SQLtable ('FIRMY', sql)
    f.update(id, upd, true)
    f.close()

    // koniec OK
    Log.info("UPDATE CUSTOMER id=$id")
    Log.debug(upd.toString())
    request.sendOk(id, "Customer updated")
}

// Naplnenie stlpcov tabulky FIRMY, transformuju sa nazvy, kontroluju sa povolene stlpce pre kazdy rezim
// vstup:  [body] = zoznam poli z requestu
//         [b2b] true=firma, false=obcan
// vystup: [upd] = zoznam poli v tabulke FIRMY, ktore sa maju updatovat
// vracia: zoznam chyb alebo prazdny retazec ak je vsetko OK
private String parseInputData (tangram.DataBuffer upd, tangram.DataBuffer body, boolean b2b)
{
    def errorList = ''
    // zoznam povolenych poli (zatial su povolene vsetky)
    def enabledFields = ['ico', 'icdph', 'dicdu', 'druh_statu', 'nazov1', 'nazov2', 'ulica', 'psc', 'mesto', 'stat', 'okres', 'kraj',
                         'adresa', 'poznamka',
                         'delivery_company', 'delivery_firstname', 'delivery_lastname', 'delivery_addr1', 'delivery_addr2', 'delivery_post', 'delivery_city', 'delivery_country',
                         'telefon', 'email', 'zlava', 'censkup', 'odbskup', 'trasa', 'obchzast', 'kluc1', 'kluc2', 'kluc3',
                         'dnis', 'ss', 'default_dl', 'default_df', 'spuhrady', 'skalias', 'c_kodbuctu']
    // ak nie je B2B, pridame k povolenym aj nazov a adresu firmy
    //    if (!b2b) enabledFields << [company_name: 'nazov1', invoice_addr1: 'ulica', invoice_addr2: 'nazov2',
    //                            invoice_post: 'psc', invoice_city: 'mesto', invoice_country: 'stat']
    // do [upd] vytvorime zoznam databazovych stlpcov s novymi hodnotami
    body.each { key, value ->
        switch (key)
        {
            case 'id':      break;
            case 'login':   upd.put('flg_eshop', value); break;
            // case 'faktura': upd.put('zakaz_f', value ? '' : 'A'); break;
            case 'delivery_shop': upd.put('xp', value); break;
            default:
                if (enabledFields.contains(key))
                    upd.put(key, value)
                else
                    errorList += "$key "
        }
    }

    return errorList
}
