// DELIVERY DETAIL opis jedneho skladoveho dokladu (standardne typu Predaj), vrati pole riadkov, JSON, UTF-8
// Parameter: ID=SKLADH.XX
urlDeliveryDetail (sql, request, json, cfg)

private void urlDeliveryDetail(tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    def id = request.queryMap.getString('id')
    tangram.Log.debug("DeliveryDetail: id=$id")

    def selectH = """
SELECT H.Xx as id, H.Druhdok, H.Cdok, H.Datum, H.D_termin, TNG.TimeToStr(H.T_termin) as T_termin, H.Spedicia, H.Sp_uhrady, H.Vs, H.Zl_f as Zlava,
    H.Rsstav as Stav, H.Trasa, H.Obchzast,
    H.Firma, H.Pobocka, TNG.FirmaXX (H.Firma, H.Pobocka) as customer_id,
    F.Nazov1, F.Nazov2, F.Ulica, F.Psc, F.Mesto, F.Stat, F.Ico, 
    H.Xp as Delivery_shop,
    H.Delivery_company, H.Delivery_firstname, H.Delivery_lastname, H.Delivery_addr1, H.Delivery_addr2, H.Delivery_post, H.Delivery_city, H.Delivery_country,
    H.Delivery_email, H.Delivery_phone,
    H.Popis,
    R.Cm_suma as Suma_bdph, R.Cd_suma as Suma_sdph, R.Pocet as Pocet_riadkov
FROM SKLADH H
LEFT JOIN FIRMY F ON (F.Xx = TNG.FirmaXX(H.Firma, H.Pobocka))
LEFT JOIN (SELECT Xh, sum(Cm_suma) as Cm_suma, sum(Cd_suma) as Cd_suma, count(*) as Pocet FROM SKLADR WHERE XH='$id' GROUP BY Xh) R ON (R.Xh=H.Xx)
WHERE H.Xx='$id'
    """.stripIndent()

    def selectR = """
SELECT R.Xn as riadok, R.Kod, R.Mnv, R.Cm_bdph as Cena_bdph, R.Cm_suma as Suma_bdph, R.Cd_cena as Cena_sdph, R.Cd_suma as Suma_sdph,
    R.Zlava, R.Sadzba_dph, R.Akcia, R.Sklad, R.Str, R.Zak, R.Kp, 
    T.Mj, T.Nazov, R.Znazov
FROM SKLADR R LEFT JOIN TOVARY T ON (T.Xx=R.Kod)
WHERE R.Xh='$id'
ORDER BY R.Xn""".stripIndent()

    def header = sql.querySingle(selectH)
    def rows = sql.queryRows (selectR)

    // Response
    request.sendHeaderJSON()
    json.begin()
    json.map(header,'header')
    json.resultset (rows, "rows")
    json.end()

    rows.close()
}
