import tangram.Log

// DELIVERYLIST zoznam dodacich listov, JSON, UTF-8
urlDeliveryList (sql, request, json, cfg)

//
private void urlDeliveryList (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    Log.debug("query=${request.queryString}")
    Log.debug("map=${request.queryMap}")

    // parametre - filter na vyhladanie dokladov
    def data        = request.queryMap
    // def kategoria   = data.getString('kategoria')
    def druhdok     = data.getString('druhdok')
    def days        = data.getInt('days', 30)
    def spedicia    = data.getString('spedicia')
    def filter      = data.getString('filter')

    // Filter pre hlavicky dokladov
    def sqlFlt      = new tangram.SQLfilter()
    sqlFlt.str('H.Druhdok', druhdok)
    if (days >= 0) sqlFlt.add("H.Datum>=(trunc(sysdate)-$days)")
    sqlFlt.str('H.Spedicia', spedicia)
    sqlFlt.add(filter)

    // Filter pre riadky, obmedzime aspon datum aby nebol sub-select prilis pomaly
    def whereRows = (days >= 0) ? "WHERE Datum >= (trunc(sysdate)-$days)" : ""

    def select = """
        SELECT H.Xx as Id, H.Druhdok, H.Cdok, H.Datum, H.Firma, H.Pobocka, H.Vs, H.Trasa, H.Obchzast, H.Spedicia, H.Sp_uhrady, H.Popis,
            F.Nazov1, F.Nazov2, F.Ulica, F.Psc, F.Mesto, F.Ico,
            H.Delivery_company, H.Delivery_firstname, H.Delivery_lastname, H.Delivery_addr1, H.Delivery_addr2, H.Delivery_post, H.Delivery_city,  
            H.Delivery_email, H.Delivery_phone, 
            R.Riadky, R.Prijem, R.PredajBezDph, R.PredajSDph
        FROM SKLADH H LEFT JOIN 
        ( SELECT Xh, count(*) as Riadky, sum(Mnp*Nadcena) as Prijem, sum(Cm_suma) as PredajBezDph, sum(Cd_suma) as PredajSDph FROM SKLADR
          $whereRows
          GROUP BY Xh
        ) R ON (R.Xh=H.Xx)
        LEFT JOIN FIRMY F ON (F.Firma || '.' || F.Pobocka = H.Firma || '.' || H.Pobocka) 
        WHERE $sqlFlt
        ORDER BY H.Datum, H.Druhdok, H.Cdok 
    """
    Log.debug("SQL: $select")
    def items = sql.queryRows (select)
    // Response header
    request.sendHeaderJSON()
    // Reponse body
    json.begin()
    json.resultset(items, 'items')
    json.end()
    items.close()
}
