import tangram.BigNumber
import tangram.Log
import tangram.DataBuffer
import businessLogic.SkUtils
import businessLogic.PriceCalc

// vlozenie objednavky, obsah je v mape body
// Vstupne parametre: request (request+response), sql (tangram.SQLConn), query (parametre requestu)
new Order().OrderCalc(sql, request, json, cfg)

class Order
{
    // Spolocne premenne
    private String customer
    private String censkup
    private BigNumber zl_f
    private rows = new ArrayList<Row>()

    // Vstupny bod
    public void OrderCalc (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
    {
        def body    = request.bodyMap
        customer = body.getString('customer')
        def firma = sql.querySingle("SELECT Censkup, Zlava FROM FIRMY WHERE Xx='$customer'")
        censkup = firma.getString('censkup', cfg.str('EshopPriceGroup'))
        zl_f    = firma.getBigNumber('zlava')
        Log.debug("CUSTOMER $customer, censkup=$censkup, zlava=$zl_f")

        // nacitanie riadkov z requestu do pola
        body.getArray('rows').each { rows.add(new Row(it)) }
        rows.each { it.calcPrice(sql, zl_f) }
        rows.each { println(it) }

        // HTTP response (hlavicka sa doplni automaticky)
        json.begin()
        json.pair('result', 'OK')
        json.arrayBegin('rows')
        rows.each {it.exportJSON(json)}
        json.arrayEnd()
        json.end()
    }

    // Jeden riadok
    class Row
    {
        // vstupne data
        private String riadok
        private String kod
        private BigNumber mn
        // vypocitane ceny
        private PriceCalc price = new PriceCalc()

        // constructor
        Row (tangram.DataBuffer data)
        {
            riadok = data.getString('riadok')
            kod = data.getString('kod')
            mn = data.getBigNumber('mn')
        }

        // vyhladanie ceny pre riadok, aplikuje aj dokladovu zlavu
        void calcPrice (tangram.SQLconn sql, tangram.BigNumber zl_f)
        {
            // POZOR: customer je teraz XX, tabulka TOVCENY zatial stale odkazuje na Firma+Pobocka
            price.find(sql, kod, censkup, java.time.LocalDate.now(), '', '', customer, '')
            price.applyDiscount(zl_f)
        }

        // zapis riadka do JSON
        void exportJSON (tangram.TangramJsonWriter json)
        {
            json.blockBegin ()
            json.pair('riadok', riadok)
            json.pair('kod', kod)
            json.pair('cm_cenn', price.cena_bdph)
            json.pair('cd_cenn', price.cena_sdph)
            json.pair('cm_cena', price.zlav_bdph)
            json.pair('cd_cena', price.zlav_sdph)
            json.pair('cm_suma', (price.zlav_bdph * mn).round(2))
            json.pair('cd_suma', (price.zlav_sdph * mn).round(2))
            json.pair('zlava', price.zlava)
            json.pair('sadzba_dph', price.sadzba_dph)
            json.pair('mena', 'EUR')
            json.pair('akcia', price.akcia)
            json.blockEnd()
        }

        @Override
        String toString() { return "riadok=$riadok, kod=$kod, mn=$mn, cena=${price.cena_bdph}, s DPH=${price.cena_sdph}" }
    }
}

