// ORDERDETAIL opis jednej objednavky, vrati pole riadkov, JSON, UTF-8
// Parameter: ID=OBPH.XX
urlOrderDetail (sql, request, json, cfg)

private void urlOrderDetail (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    def id = request.queryMap.getString('id')
    tangram.Log.debug("OrderDetail: $id")

    def selectH = """
        SELECT H.Xx as id, H.Druhdok, H.Cdok, H.Extcis, H.Datum, 
            (select sum(Cd_suma) from OBPR where Xh=H.Xx) as Suma,
            H.Firma || nvl2 (H.Pobocka, '.' || H.Pobocka, '') as customer_id,
            H.Rsstav as Stav, C.Nazov as StavNazov,
			H.Trasa, H.Referent, H.Telefon, H.Sklad, H.Censkup, H.Zl_f, H.Spedicia, H.Sp_uhrady, H.Vs_uhrady,
            H.Xp as Delivery_shop,
            H.Delivery_company, H.Delivery_firstname, H.Delivery_lastname, H.Delivery_addr1, H.Delivery_addr2, H.Delivery_post, H.Delivery_city, H.Delivery_country,
            H.Delivery_email, H.Delivery_phone
        FROM OBPH H
		LEFT JOIN C_OBPSTAV C ON (C.Xx=H.Rsstav)
        WHERE H.Xx='$id'
        ORDER BY H.Datum, H.Druhdok, H.Cdok
    """.stripIndent()
    def selectR = """
        SELECT R.Xn as riadok, R.Kod, R.Mn, R.Mndod, R.Cm_bdph as Cm_cena, R.Cm_suma, R.Cd_cena, R.Cd_suma, R.Zlava, R.Sadzba_dph, R.Akcia, 
            T.Mj, T.Nazov, R.Znazov
        FROM OBPR R LEFT JOIN TOVARY T ON (T.Xx=R.Kod)
        WHERE R.Xh='$id'
        ORDER BY R.Xn
    """.stripIndent()

    def header = sql.querySingle(selectH)
    def rows = sql.queryRows (selectR)

    // Response
    request.sendHeaderJSON()
    json.begin()
    json.map(header,'header')
    json.resultset (rows, "rows")
    json.end()

    rows.close()
}
