// ORDERLIST zoznam objednavok, vrati pole riadkov, JSON, UTF-8
urlOrderList(sql, request, json, cfg)

private void urlOrderList (tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    def days = request.queryMap.getInt('days', 365)
    def customer = request.queryMap.getString('customer')
    def customerFirma = businessLogic.SkUtils.firmaFirma(customer)
    def customerPobocka = businessLogic.SkUtils.firmaPobocka(customer)
    def filter = new tangram.SQLfilter()
    filter.and("H.Datum >= (trunc(sysdate)-$days)")
    filter.strExact("H.Firma", customerFirma)
    filter.strExact("H.Pobocka", customerPobocka)

    def select = """
        SELECT H.Xx as id, H.Druhdok, H.Cdok, H.Extcis, H.Datum, 
            (select sum(Cd_suma) from OBPR where Xh=H.Xx) as Suma,
            H.Firma || nvl2 (H.Pobocka, '.' || H.Pobocka, '') as customer_id,
            H.Rsstav as Stav, H.Trasa, H.Referent, H.Telefon, H.Sklad, H.Censkup, H.Zl_f, H.Spedicia, H.Sp_uhrady, H.Vs_uhrady,
            H.Xp as Delivery_shop,
            H.Delivery_company, H.Delivery_firstname, H.Delivery_lastname, H.Delivery_addr1, H.Delivery_addr2, H.Delivery_post, H.Delivery_city, H.Delivery_country,
            H.Delivery_email, H.Delivery_phone
        FROM OBPH H
        WHERE $filter
        ORDER BY H.Datum, H.Druhdok, H.Cdok
    """
    tangram.Log.debug("ORDERLIST: $filter")

    def orders = sql.queryRows (select)

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.resultset (orders, "orders")
    json.end()
    orders.close()
}
