import tangram.Log

// Alternativne udaje k tovarom (vracia len tovary, ku ktorym existuju alter-udaje)
// [productId] = kod tovaru, vrati jeden zaznam
// [alterId] = kod alternativnej skupiny (obvykle kod jazyka pre cudzojazycne nazvy)
// ziaden parameter = export vsetkych tovarov s priznakom "e-shop" pre vsetky skupiny
urlProductAlterList (sql, request, json, cfg)

private static void urlProductAlterList(tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    // parametre requestu
    def params = request.queryMap
    def productId = params.getString('productid')
    def alterId = params.getString('alterid')

    // SELECT
    def sqlFilter = createFilter (productId, alterId)
    Log.debug("filter: $sqlFilter")
    def rs = sql.queryRows("""
        SELECT A.Kod as ProductId, A.Alias as AlterId, A.Anazov as Name, A.Amj as unit 
        FROM SKALIAS A LEFT JOIN TOVARY T ON (T.Xx=A.Kod)
        WHERE $sqlFilter 
        ORDER BY A.Kod, A.Alias""".stripMargin())

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.resultset(rs, 'items')
    json.end()

    Log.debug("rows: ${rs.getRow()}")
    rs.close()
}

// Vytvorenie SQL filtra pre select
private static String createFilter (String productId, String alterId)
{
    def sqlFilter = new tangram.SQLfilter()
    sqlFilter.str("A.Kod", productId)
    sqlFilter.str("A.Alias", alterId)
    sqlFilter.add("T.Flg_eshop is not null")
    return sqlFilter.toString()
}
