// zoznam vsetkych platnych cien, query-parametre:
// [id]=kod tovaru, vrati jeden zaznam
// ziaden parameter = export vsetkych tovarov s priznakom "e-shop"
urlPriceListAll (sql, request, json, cfg)

private static void urlPriceListAll(tangram.SQLconn sql, tangram.http.TangramHttpRequest request, tangram.TangramJsonWriter json, tangram.ConfigFile cfg)
{
    // Parametre z URL a konfiguracie (Tangram.ini)
    def id = request.queryMap.getString('id').toUpperCase()
    def censkup = cfg.str('EshopPriceGroupAll')
    def typceny = cfg.str('EshopPriceTypeAll', "'A','B','E'")
    def tovfilter = 'T.Flg_eshop is not null' + (id ? " and T.Xx='${id}'" : '')
    def cenfilter = "C.Typceny in ($typceny) and (trunc(sysdate) between C.Datum_od and C.Datum_do)" + (censkup ? " and C.Censkup='${censkup}'" : '')

    // API REQUEST: ciselnik sluzieb z tabulky TOVARY, optional filters: id=kod_tovaru
    // warning: parameter [id] sa z nejakeho dovodu neda pouzit vo where :id, musime urobit inject (skontrolovat SQL class)
    def select = """
    SELECT C.Kod "id", T.Druh "group", T.Nazov "name", T.Mj "unit", B.Barcode "barcode", T.Znacka "trademark", T.Prodskup "prodgroup",
        C.Censkup "pricegroup", C.Typceny "pricetype", C.Sadzba_dph "pricevat", C.Cm_sdph "priceinc", C.Cm_bdph "priceexc", 
        C.Zl_typ "discounttype", C.Zl_t "discountvalue", C.Akcia "promotion", C.Firma "customer"
    FROM TOVCENY C JOIN TOVARY T ON (C.Kod=T.Xx)
    LEFT JOIN TOVBARCODE B ON (B.Kod=C.Kod and B.Hlavny is not null)
    WHERE $tovfilter and $cenfilter 
    ORDER BY C.Kod, C.Censkup, C.Typceny, C.Datum_od
    """

    def rows = sql.queryRows(select)

    // Response header
    request.sendHeaderJSON()

    // Reponse body
    json.begin()
    json.resultset(rows, 'items')
    json.end()
    rows.close()

}