import tangram.ConfigFile
import tangram.DataBuffer
import tangram.Log
import tangram.SMTP
import tangram.SQLconn
import tangram.TangramJsonParser
import tangram.TangramJsonWriter
import tangram.http.HTTPSClient
import tangram.http.TangramHttpRequest

// AMBER ROAD, overovanie zakaznika
// Parametre requestu: CUSTOMER=kod zakaznika alebo ORDERS
// Kontrola CUSTOMER je volana v TangramEOS, vracia sa PlainText odpoved, 1.riadok=N/P/M/ERROR, 2. riadok=text chyby
// Kontrola ORDERS je volana pravidelne zo schedulera, vracia PlainText zoznam objednavok (postupne aby nenastal timeout)
new AmberRoadWorker().startScript(sql, request, json)

//
class AmberRoadWorker
{
    // Parametre pre vyber objednavok a formatovanie spravy pre AR
    def country    = 'CZ'
    def orgCode    = 'PPG_EMEA_ARC_' + country
    def orderFilter = "Datum>(trunc(sysdate)-7) and Druhdok='ESHOP' and Rsstav in ('0','2')"

    // Parametre pre ziskanie TOKENU z OAuth2 servera
    def authUrl     = 'https://login.microsoftonline.com/9dfd1e5e-bb06-40df-8eeb-2a295fe4dda5/oauth2/v2.0/token'
    def authId      = 'e5dcb664-3c40-4572-ba7b-6815de6737c6'
    def authSecret  = 'uPr7Q~SCRGb8lKDxJNSumweHAOQzCZSg5c46f'
    def authScope   = 'api://99394137-3d3d-4042-8646-9aac976aa411/.default'

    // Parametre API na overenie identity zakaznika
    def urlAPI     = 'https://api.ppg.com/external/PROD-gbl-rps/api/v1/Screening'
    def ocpApimKey = '965206c55e4844a0848e15fa8abddf7b'

    // SMTP klient - odoslanie mailu
    def smtp = new SMTP()
    def smtpHost   = '192.168.1.12'
    def smtpLogin  = 'jculakova'
    def smtpPassword = 'jitkac'
    def mailSender  = 'tangram@dumbarev.cz'
    def mailWarning = 'ics.ecvessels.emea@ppg.com,milan.durdik@ppg.com'
    def mailError   = 'mbilinski@ppg.com,milan.durdik@ppg.com'

    /* TESTOVACI AMBER ROAD
        def authUrl    = 'https://login.microsoftonline.com/9dfd1e5e-bb06-40df-8eeb-2a295fe4dda5/oauth2/v2.0/token'
        def authId     = 'd959f4af-9ed4-4ade-81d2-98e4671e116a'
        def authSecret = 'hOmYetdb~s3Z0Ljl7DIZ.Cmv_DyL-rMQ~0'
        def authScope  = 'api://f798ea97-ea6a-42d1-b041-6486c691808b/.default'
        def urlAPI     = 'https://API-Test.ppg.com/external/DEV-gbl-rps/api/v1/Screening'
     */
    // Startovaci bod skriptu
    void startScript (SQLconn sql, TangramHttpRequest request, TangramJsonWriter json)
    {
        Log.info("Amber Road")

        smtp.host   = smtpHost
        smtp.port   = 25
        smtp.auth   = true
        smtp.tls    = false
        smtp.login  = smtpLogin
        smtp.password = smtpPassword
		
        def params = request.queryMap
        if (params.containsKey('orders'))
            runOrders(sql, request)
        else if (params.containsKey('customer'))
            runCustomer (sql, request, params.getString('customer'))
        else
            request.sendError('', 'URL', 'Bad request params (CUSTOMER=xxx or ORDERS), found ' + request.queryString)
    }

    // --- TOP LEVEL ENTRY POINTS ---
    // Kontrola novych objednavok, nastavenie
    private void runOrders(SQLconn sql, TangramHttpRequest request)
    {
        Log.info("Check new Orders")

        // Kontrola, ci existuju nove objednavky
        if (!ordersExist(sql))
        {
            request.sendOk('', 'No new orders found')
            return
        }

        // autorizacny token
        def token = requestAuthToken()
        if (token.isEmpty())
        {
            request.sendError('', 'AUTH', 'Authentication error (see log)')
            return
        }
        Log.debug("Authentication: access granted")
        // pockame, lebo niekedy vrati chybu 504 Gateway Time-out (Microsoft-Azure-Application-Gateway/v2)
        sleep(1000)

        // Kontrola objednavok
        Log.info("Checking Orders")
        ordersCheck(sql, token, request)
    }
    // Kontrola jedneho zakaznika z tabulky FIRMY
    private void runCustomer(SQLconn sql, TangramHttpRequest request, String customer)
    {
        Log.info("Check Customer $customer")

        // autorizacny token
        def token = requestAuthToken()
        // def token = "TEST-ABCDEFGH"
        if (token.isEmpty())
        {
            request.sendError('', 'AUTH', 'Authentication error (see log)')
            return
        }
        Log.debug("Authentication: access granted")
        // pockame, lebo niekedy vrati chybu 504 Gateway Time-out (Microsoft-Azure-Application-Gateway/v2)
        sleep(1000)

        //
        def data = sql.querySingle("SELECT * FROM Firmy WHERE Xx='$customer'")
        def json = new TangramJsonWriter()

        json.begin()
        json.pair("partnerID", data.xx)
        json.pair("orgCode", orgCode)
        json.pair("name", data.getString('nazov1') + ' ' + data.getString('nazov2'))
        json.pair("contactName", data.delivery_firstname + ' ' + data.delivery_lastname)
        json.pair("secondaryContactName",null)
        json.pair("address1", data.ulica)
        json.pair("address2", null)
        json.pair("address3", null)
        json.pair("city", data.mesto)
        json.pair("stateCode", null)
        json.pair("stateName", null)
        json.pair("postalCode", data.psc)
        json.pair("countryCode", data.stat ?: country)
        json.pair("countryName", null)
        json.pair("imoVesselNumber", null)
        json.pair("forceReScreen", "N")
        json.pair("forceReScreenSpecified", false)
        json.pair("skipNewRPL", "N")
        json.pair("skipNewRPLSpecified", false)
        json.pair("flexField1", 'CUSTCREATE')              //pidno 25.5.2022
        json.pair("persistPartner", "Y")
        json.pair("persistPartnerSpecified", true)
        json.pair("returnFullPartnerInformation", "Y")
        json.pair("returnFullPartnerInformationSpecified", true)
        json.pair("returnFullMatchDetail", "Y")
        json.pair("returnFullMatchDetailSpecified", true)
        json.end()

        // Odoslanie poziadavky do Amber Road, vrati sa analyzovany vysledok
        Result result = sendMessage(json.toString(), token)

        // Odoslanie vysledku volajucemu (plain text), v tomto pripade by to mal byt TangramEOS
        request.sendHeader(HttpURLConnection.HTTP_OK)
        def writer = request.getWriter()
        writer.println(result.code)
        writer.println([N: 'NO MATCH', P: 'PARTIAL MATCH', M: 'FULL MATCH'].get(result.code))
        writer.println(result.text)
    }

    // --- COMMON FUNCTIONS ---
    /**
     * Vyziadanie autentifikacneho tokenu
     * [return] token alebo prazdny retazec (nikdy null)
     */
    private String requestAuthToken()
    {
        Log.info("Authentication: requesting access token")
        // sleep(1000)
        // return 'ABCDEFGH-TOKEN'

        def title = "AUTHENTICATION ERROR $authUrl\nCredentials $authId:$authSecret"
        // Vyziadanie autentifikacneho tokenu z OAuth2 servera v rezime CLIENT CREDENTIALS
        // Autentifikacne data sa posielaju cez POST, kodovane ako FORM, odpoved prichadza v JSON
        def client = new HTTPSClient(authUrl)
        client.setHeader("Content-Type", "application/x-www-form-urlencoded")
        def body = "grant_type=client_credentials&client_id=$authId&client_secret=$authSecret&scope=$authScope"
        Log.debug("Authentication: " + body)
        client.post(body)
        if (client.isError())
        {
            Log.error("$title\nResponse code ${client.responseCode} ${client.responseMsg}\n${client.responseText}")
            return ""
        }
        // vytiahnutie tokenu z JSON odpovede
        Log.debug("REPLY FROM AUTH SERVER:\n" + client.responseText)
        def json = new TangramJsonParser()
        def data = json.parse(client.responseText)
        def token = data.getString("access_token")
        if (token.isEmpty())
            Log.error("$title\nResponse code ${client.responseCode} ${client.responseMsg}\n${client.responseText}")
        return token
    }

    /**
     * Odoslanie jednej spravy
     * [docJson] sprava naformatovana do JSON
     * [token] autentifikacny token, spolocny pre vsetky naraz odosielane spravy
     * [return] response body so zoznamom chyb (JSON format)
     */
    private Result sendMessage(String docJson, String token)
    {
        // MOCK
        // sleep(2000)
        // return new Result('N','')
        // return new Result('P','toto je mozno terorista')
        // return new Result('M','toto je urcite terorista')

        // Priprava hlavicky
        def client = new HTTPSClient(urlAPI)
        client.setHeader('Authorization', 'Bearer ' + token)
        client.setHeader('Ocp-Apim-Subscription-Key', ocpApimKey)
        client.setHeader('Content-Type', 'application/json')

        // Poslanie spravy POST
        client.post(docJson)
        Log.debug("HTTP REQUEST:$urlAPI")
        Log.debug("DATA:" + docJson)
        Log.debug("HTTP RESPONSE ${client.responseCode}:${client.responseText}")
        Log.debug("RESPONSE HEADERS:\n${client.connection.headerFields}")

        // Analyza navratoveho kodu, chyba sa zapise do logu, vratime prazdny string, program pokracuje dalej
        int responseCode = client.responseCode
        if (responseCode >= 200 && responseCode < 300)
        {
            return parseResponse (client.responseText)
        }
        else
        {
            def errorText = "Amber Road server error, code=$responseCode\n${client.connection.headerFields}"
            Log.error(errorText)
            return new Result('ERROR', errorText)
        }
    }

    // Analyza odpovede od Amber Road. Vracia Result s vysledkom N/P/M a podrobnejsim textom
    private Result parseResponse (String responseAR)
    {
        // parsing JSON odpovede do mapy
        def json = new TangramJsonParser()
        def data = json.parse(responseAR)
        // analyza dat
        // decision: N=no match, P/M=possible or exact match
        def decision = data.getString('decision')
        // Ak nie je ziadna zhoda v databaze, vratime kod "N" bez dalsieho textu
        if (decision=='N') return new Result(decision, '')
        // Ak je P alebo M, tak analyzujeme vyhladame podrobnejsi popis
        String errorText = "no result details"
        def entity = data.get('entity')
        if (entity != null)
        {
            Log.debug("Entity=" + entity.toString())
            Log.debug("Class =" + entity.class.getName())
            if (entity instanceof java.util.List) {
                // "Entity" je pole, moze byt viac zhodnych retazcov, my berieme len prvy z nich
                def first = entity.first()
                Log.debug("First=" + first.toString())
                def entityId = first.entityid
                def rplType = first.rpltype
                def rplCtryCode = first.rplctrycode
                def matchScore = first.matchscore
                errorText = "ID=$entityId Type=$rplType Country=$rplCtryCode Match=$matchScore"
            }
        }
        return new Result(decision, errorText)
    }

    // --- ORDERS FUNCTIONS ---
    /**
     * Kontrola, ci existuju nepotvrdene objednavky v databaze
     * @param connection SQL connection
     * @return true=objednavky existuju, false=ziadna objednavka nenajdena
     */
    private boolean ordersExist (SQLconn connection)
    {
        def count = connection.queryValueInt("SELECT count(*) FROM OBPH WHERE " + orderFilter)
        Log.debug("Orders found $count")
        return count>0
    }

    private void ordersCheck (SQLconn connection, String token, TangramHttpRequest request)
    {
        // Generovanie odpovede pre volajuceho, po kazdom zazname dopiseme a flushneme aby nedoslo k timeoutu
        request.addHeader("Content-Type", "text/plain; charset=utf-8")
        request.sendHeader()

        // Cyklus pre objednavky
        def orders = connection.queryRows("SELECT * FROM OBPH WHERE " + orderFilter + " ORDER BY Druhdok, Cdok")
        while (orders.next())
        {
            Log.debug("ORDER ${orders.row}. ${orders.data}")
            def jsonData = orderCreateMsg (orders.data)
            def result = sendMessage(jsonData, token)
            // Zapis vysledku do response body po kazdej objednavke
            request.writer.println(orders.getString('druhdok') + '/' + orders.getBigNumber('cdok') + ' ' + result)
            request.writer.flush()
            // Zapis vysledku do objednavky
            orderUpdate(result, orders.data, connection)
            // Odoslanie mailu pre podozrive objednavky
            orderEmail(result, orders.data)
        }
        orders.close()
    }

    /**
     * Formatovanie dat z objednavky do JSON
     * @param data hlavicka objednavky
     * @return data z hlavicky naformatovane do JSON
     */
    private String orderCreateMsg(DataBuffer data)
    {
        def json = new TangramJsonWriter()
        json.begin()

        def name = data.delivery_firstname + ' ' + data.delivery_lastname
        json.pair("partnerID", data.xx)
        json.pair("orgCode", orgCode)
        json.pair("name", data.delivery_company ?: name)
        json.pair("contactName", name)
        json.pair("secondaryContactName",null)
        json.pair("address1", data.delivery_addr1)
        json.pair("address2", data.delivery_addr2)
        json.pair("address3", null)
        json.pair("city", data.delivery_city)
        json.pair("stateCode", null)
        json.pair("stateName", null)
        json.pair("postalCode", data.delivery_post)
        json.pair("countryCode", data.delivery_country ?: country)
        json.pair("countryName", null)
        json.pair("imoVesselNumber", null)
        json.pair("forceReScreen", "N")
        json.pair("forceReScreenSpecified", false)
        json.pair("skipNewRPL", "N")
        json.pair("skipNewRPLSpecified", false)
        json.pair("flexField1", 'OTC')                               //zmna z hodnoty null na 'OTC'  25.5.2022
        json.pair("flexField2", null)
        json.pair("flexField3", null)
        json.pair("flexField4", null)
        json.pair("flexField5", null)
        json.pair("persistPartner", "Y")
        json.pair("persistPartnerSpecified", true)
        json.pair("returnFullPartnerInformation", "Y")
        json.pair("returnFullPartnerInformationSpecified", true)
        json.pair("returnFullMatchDetail", "Y")
        json.pair("returnFullMatchDetailSpecified", true)

        json.end()
        return json.toString()
    }

    /**
     * Analyza odpovede (JSON), vysledok sa zapise do hlavicky objednavky
     * @param responseJson
     */
    private void orderUpdate(Result result, DataBuffer obph, SQLconn connection)
    {
        def obphXx = obph.getString('xx')
        def oldRsstav = obph.getString('rsstav')
        def newRsstav = 'X'
        def newPopis = 'X'

        // Vypocet noveho stavu objednavky a popisu podla vysledku z AR
        switch (result.code)
        {
            case 'N':
                newRsstav = '1'
                newPopis = 'Amber Road CHECK OK'
                break
            case 'P':
                newRsstav = '2'
                newPopis = 'Amber Road POSSIBLE MATCH: ' + result.text.take(200)
                break
            case 'M':
                newRsstav = '7'
                newPopis = 'Amber Road BLOCKED: ' + result.text.take(200)
                break
        }

        // Ak sa zmenil stav objednavky, tak ho prepiseme (pri opakovanom re-check sa nebude menit, kym sa nezmeni v databae AR)
        if (newRsstav != 'X' && newRsstav != oldRsstav)
            connection.execute("UPDATE OBPH SET Rsstav='$newRsstav', Popis='$newPopis', Xuo=user, Xud=sysdate WHERE Xx='$obphXx'")
    }

    // Odoslanie e-mailu pre 'P' a 'ERROR', vsetky ostatne odpovede sa ignoruju
    private void orderEmail(Result result, DataBuffer obph)
    {
        try
        {
            // sprava pre POSSIBLE MATCH (nerozhodnuta objednavka), za sa posiela pri kazdom opakovanom teste
            if (result.code == 'P')
            {
                smtp.clearBody()
                smtp.setMsgFrom(mailSender)
                Log.info("Sending email to $mailWarning")
                smtp.setMsgTo(mailWarning)
                smtp.setMsgSubject("$country Amber Road warning")
                def text = """
                    |AMBER ROAD WARNING, COUNTRY=$country
                    |ORDER: ${obph.druhdok}/${obph.cdok} ${obph.datum}
                    |Partner ID: ${obph.xx}
                    |Name: ${obph.delivery_firstname} ${obph.delivery_lastname}
                    |Company: ${obph.delivery_company}
                    |Email: ${obph.delivery_email}
                    |Shop: ${obph.sklad}
                    |
                    |STATUS: ${result.code}
                    |
                    |${result.text}""".stripMargin()
                smtp.addText(text)
                smtp.send()
            }
            // sprava pre SYSTEM ERROR (nedostali sme odpoved od AR servera alebo prisla chybova hlaska)
            if (result.code == 'ERROR')
            {
                smtp.clearBody()
                smtp.setMsgFrom(mailSender)
                Log.info("Sending email to $mailError")
                smtp.setMsgTo(mailError)
                smtp.setMsgSubject("$country Amber Road error")
                def text = """
                    |AMBER ROAD ERROR, COUNTRY=$country
                    |ORDER: ${obph.druhdok}/${obph.cdok} ${obph.datum}
                    |Partner ID: ${obph.xx}
                    |Name: ${obph.delivery_firstname} ${obph.delivery_lastname}
                    |Company: ${obph.delivery_company}
                    |Email: ${obph.delivery_email}
                    |Shop: ${obph.sklad}
                    |
                    |STATUS: ${result.code}
                    |
                    |${result.text}""".stripMargin()
                smtp.addText(text)
                smtp.send()
            }
        }
        catch (Exception e)
        {
            // chybu pri odoslani mailu len zalogujeme, ale neprerusime operaciu
            Log.error(e)
        }
    }

    // ulozena odpoved od AR servera
    private class Result
    {
        // enum Code {N, P, M, ERROR}
        // Result code: "N", "P", "M" or "ERROR" (system error)
        String code
        String text

        Result(String code, String text) {
            this.code = code
            this.text = text
        }

        @Override
        String toString() { return code + ' ' + text }
    }
}
