import businessLogic.ppg.CouponService
import tangram.DataBuffer
import tangram.JsonWriter
import tangram.SQLconn
import tangram.http.TangramHttpRequest
// COUPON VALIDATE, kontrola platnosti PROMO kuponu
// Parametre requestu: CUSTOMER=kod zakaznika, COUPON=kod kuponu
urlCouponValidate(sql, request)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlCouponValidate(SQLconn sql, TangramHttpRequest request)
{
    def prm = request.queryMap
    def customerId = prm.getString('customer')
    def couponId = prm.getString('coupon').toUpperCase()

    // Kontrola kuponu
    def result = CouponService.checkCoupon(sql, couponId, customerId)
    def coupon = result.coupon;

    // Response header
    request.sendHeaderJSON()
    // Reponse body
    def data = new DataBuffer()
    data.put('result', result.result ? 'OK' : 'ERROR')
    data.put('errid', result.errId)
    data.put('errtext', result.errText)
    data.put('customer_id', customerId)
    data.put('coupon_id', couponId)
    data.put('coupon_name', coupon.nazov)
    JsonWriter.write(request.writer, data)
}
