import businessLogic.ppg.PpgOrder
import tangram.JsonWriter
import tangram.Log
import tangram.SQLconn
import tangram.http.TangramHttpRequest
// ORDER COPY, vytvorenie kopie existujucej objednavky, vracia data naformatovanie rovnako ako OrderCreate/Sim
// Parametre requestu: ID=unique ID povodnej objednavky
urlOrderCreate(sql, request)

// Zoznam skladov (predajni) - exportuju sa vsetky okrem velkoskladov
private static void urlOrderCreate(SQLconn sql, TangramHttpRequest request)
{
    def orderId = request.queryMap.getString("order_id")
    if (!orderId) Log.error("Nezadaný parameter ORDER_ID (kód objednávky)")

    // objednavka sa nacita z databazy, prepocitaju sa ceny a delivery, vrati sa obsah
    def order = new PpgOrder()
    order.loadDB(sql, orderId)
    order.calculatePrices(sql)
    order.calculateDelivery(sql)

    // Response header + body
    request.sendHeaderJSON()
    JsonWriter.write(request.writer, order)
}
