import businessLogic.ppg.PpgOrder
import businessLogic.ppg.XpShopCode
import tangram.CfgApp
import tangram.JsonWriter
import tangram.Log
import tangram.SQLconn
import tangram.http.TangramHttpRequest
// ORDERDETAIL - vrati jednu objednavku, povinny parameter ORDER_ID = (OBPH.XX)
urlOrderDetail (sql, request)

private static void urlOrderDetail (SQLconn sql, TangramHttpRequest request)
{
    def orderId = request.queryMap.getString("order_id")
    if (!orderId) Log.error("Nezadaný parameter ORDER_ID (kód objednávky)")

    // Cela objednavka sa nacita do pamate
    def order = new PpgOrder()
    order.loadDB(sql, orderId)

    // doplnenie prefixu do kodu predajne (14.11.2022)
    order.header.delivery_shop = XpShopCode.addPrefix(order.header.delivery_shop, CfgApp.eshopCountry)

    // Response header + body
    request.sendHeaderJSON()
    JsonWriter.write(request.writer, order)
}
