package tangram

import businessLogic.FAV
import businessLogic.TN_MSG
import businessLogic.TN_MSG_DATA

// PPG vytvorenie "zalohovej" FAV k OBP zaplatenej vopred (cez platobnu branu)
// FAV.OBJCIS = OBPH.DRUHDOK/CDOK (nase interne cislo)
// FAV.SP_UHRADY = uhradene vopred
processOrderPayments(sql)

// Kontrola MSG-queue, hladame spravy "OrderPayment"
private static processOrderPayments (SQLconn sql)
{
    def listMsg = TN_MSG.list(sql, "OrderPayment")
    Log.INSTANCE.info("ORDER PAYMENT (vytvorenie faktúr k zaplateným objednávkam), počet ${listMsg.size()}")

    // prejdeme vsetky spravy a vytvarame faktury, po tom zapiseme potvrdenie spravy
    listMsg.eachWithIndex { TN_MSG_DATA msg, int i ->
        // vytvorenie faktury, msg.data obsahuje OBPH.XX, vrati informaciu o fakture
        def info = createFAV(sql, msg.data)
        // potvrdenie spravy, zapis vysledku (informacia o fakture)
        TN_MSG.markProcessed(sql, msg.xx, info)
    }

}

// Odoslanie vsetkych produktov s novsim timestampom
private static String createFAV(SQLconn sql, String xxObp)
{
    // Hlavicka objednavky
    def obph = sql.querySingle("SELECT * FROM OBPH WHERE Xx='$xxObp'")
    if (obph.getString("xx").isEmpty())
        return "Objednávka nenájdená, kód $xxObp"

    // buffer pre fakturu
    def fav = new FAV(sql)

    // hlavicka faktury
    fav.df      = "DDE"
    fav.faktc   = ""      // cislo faktury sa vygeneruje
    fav.vs      = obph.getString("vs_uhrady")
    fav.objcis  = "${obph.druhdok}/${obph.cdok}"
    fav.str     = obph.xp
    fav.c       = "CZK"
    fav.firma   = obph.firma
    fav.pobocka = obph.pobocka
    fav.xp      = obph.xp

    // Sumarizacia riadkov podla sadzby DPH
    def select ="SELECT Sadzba_dph, sum(round(Mn*Cm_sdph,2)) as Suma FROM OBPR WHERE Xh='$xxObp' GROUP BY Sadzba_dph ORDER BY 1"
    def rs = sql.queryRows(select)
    while (rs.next())
    {
        def dph = rs.getBigNumber("sadzba_dph")
        def suma = rs.getBigNumber("suma")
        fav.dphZhora("VY$dph", dph, suma)
        // println("${rs.row}. $dph% $suma")
    }
    rs.close()

    // doplnenie a dopocitanie poloziek, ulozenie do databazy
    fav.saveToDB()

    def info = "Objednávka ${obph.druhdok}/${obph.cdok} ${obph.datum}, faktúra ${fav.df}/${fav.faktc}, var.symbol ${fav.vs}"
    Log.INSTANCE.info ("PPG OBP->FAV $info")
    return info
}
