import tangram.Log
import tangram.SQLconn
import tangram.TangramJsonWriter
import tangram.http.TangramHttpRequest

// QUOTE REJECT: zamietnutie cenovej ponuky, JSON, UTF-8
// data cez POST
execute(sql, request, json)

private void execute(SQLconn sql, TangramHttpRequest request, TangramJsonWriter json)
{
    def data = request.bodyMap
    def id = data.getString('quote_id')
    Log.debug("QUOTE REJECT quote_id=" + id)

    // Kontroly
    if (id.size() != 16) { request.sendError(id, "ILLEGAL", "Illegal ID format (16 chars)"); return}

    def obph = sql.querySingle("SELECT Xx, Stav FROM OBCPH WHERE Xx='$id'")
    if (! obph.xx) { request.sendError(id, "NOTFOUND", "Unknown quote ID"); return }
    if (obph.stav != 'A') { request.sendError(id, "NOTOPEN", "Quote is not opened"); return }

    // Oznacit ponuku za zamietnutu
    sql.execute("UPDATE OBCPH SET Stav='C' WHERE Xx='$id'")

    // koniec OK
    Log.info("QUOTE REJECT, id=$id")
    request.sendOk(id, 'Quote rejected')
}

